DUDEN SPELLCHECKER FOR TINYMCE Version 1.5.8
=============================================

Copyright (c) 2016-2022 by EPC Consulting & Software

Contact:
        www.epc.de
        info@epc.de

You can always find the most recent version of this software at

  https://services.epc.de/dks/tinymce-plugin/tinymce-plugin.zip

This software contains third party libraries that are distributed under their own terms (see LICENSE-3RD-PARTY.txt). 



This plugin enriches TinyMCE with spellchecking via the Duden Correction Server.

INSTALLATION (TinyMCE 6.*)
--------------------------

Please follow these steps for installing the plugin to your TinyMCE instance.

* Requirements
    * The source files must be served via a PHP-enabled web server.
* Set the Duden Correction Server (DKS) credentials in duden/php/duden-correction-server-connector.php. Do _not_ provide any credentials if the DKS is not protected by username and password.
* Verify that $DCS_URL points to the API of the DKS and that this URL is reachable, e. g. by trying the command "wget $DCS_URL/version"
* Put the duden directory into the TinyMCE plugins directory (tinymce/plugins).
* Add "duden" to the plugins setting.
* To enable the spellchecking button, add "duden_check" to the toolbar setting.
* To enable the advanced language selection mode, where the language can be set for individual paragraphs, add "duden_lang" to the toolbar setting.
* To enable the duden menu toobar button, add "duden_menu" to the toolbar setting.
* Since only markup created by TinyMCE is supported, add the option "paste_as_text".
* Add the plugin to the context menu (you may need to add other plugins to the contetx menu depending on your configuration)
* Example
    ```
    tinymce.init({
        selector: "textarea",
        plugins: "duden",
        paste_as_text: true,
        toolbar: "duden_check"
        contextmenu: "duden"
    });
    ```

INSTALLATION (TinyMCE 5.*)
--------------------------

Please follow these steps for installing the plugin to your TinyMCE instance.

* Requirements
    * The source files must be served via a PHP-enabled web server.
* Set the Duden Correction Server (DKS) credentials in duden/php/duden-correction-server-connector.php. Do _not_ provide any credentials if the DKS is not protected by username and password.
* Verify that $DCS_URL points to the API of the DKS and that this URL is reachable, e. g. by trying the command "wget $DCS_URL/version"
* Put the duden directory into the TinyMCE plugins directory (tinymce/plugins).
* Add "duden" to the plugins setting.
* To enable the spellchecking button, add "duden_check" to the toolbar setting.
* To enable the advanced language selection mode, where the language can be set for individual paragraphs, add "duden_lang" to the toolbar setting.
* To enable the duden menu toobar button, add "duden_menu" to the toolbar setting.
* Since only markup created by TinyMCE is supported, add the option "paste_as_text", provided by the plugin "paste".
* Add the plugin to the context menu (you may need to add other plugins to the contetx menu depending on your configuration)
* Example
    ```
    tinymce.init({
        selector: "textarea",
        plugins: "duden,paste",
        paste_as_text: true,
        toolbar: "duden_check"
        contextmenu: "duden"
    });
    ```


INSTALLATION (TinyMCE 4.*)
--------------------------

Please follow these steps for installing the plugin to your TinyMCE instance.
* Requirements
    * The source files must be served via a PHP-enabled web server.
* Set the Duden Correction Server (DKS) credentials in duden/php/duden-correction-server-connector.php. Do _not_ provide any credentials if the DKS is not protected by username and password.
* Verify that $DCS_URL points to the API of the DKS and that this URL is reachable, e. g. by trying the command "wget $DCS_URL/version"
* Put the duden directory into the TinyMCE plugins directory (tinymce/plugins).
* Add "duden" to the plugins setting.
* To enable the spellchecking button, add "duden_check" to the toolbar setting.
* To enable the advanced language selection mode, where the language can be set for individual paragraphs, add "duden_lang" to the toolbar setting.
* Since only markup created by TinyMCE is supported, add the option "paste_as_text", provided by the plugin "paste".
* Example
    ```
    tinymce.init({
        selector: "textarea",
        plugins: "duden,paste",
        paste_as_text: true,
        toolbar: "duden_check"
    });
    ```


INSTALLATION (TinyMCE 3.*)
--------------------------

* Requirements
    * The source files must be served via a PHP-enabled web server.
* Set the Duden Correction Server credentials in duden/php/duden-correction-server-connector.php. Do _not_ provide any credentials if the DKS is not protected by username and password.
* Verify that $DCS_URL points to the API of the DKS and that this URL is reachable, e. g. by trying the command "wget $DCS_URL/version"
* Put the duden directory into the TinyMCE plugins directory (tinymce/jscripts/tiny_mce/plugins).
* Add "duden" to the plugins setting.
* To enable the Duden menu, add "duden_menu" to the advanced buttons setting.
* To enable the spellchecking button, add "duden_check" to the advanced buttons setting.
* To enable the advanced language selection mode, where the language can be set for individual paragraphs, add "duden_lang" to the advanced buttons setting.
* Since only markup created by TinyMCE is supported, add the option "paste_as_text", provided by the plugin "paste".
* In order to have dialogs not show up in a separate window (which might be blocked by browsers), enabling the plugin "inlinepopups" is recommended.
* Example
    ```
    tinymce.init({
        selector: "textarea",
        plugins: "duden,paste,inlinepopups",
        paste_as_text: true,
        theme_advanced_buttons3_add: "duden_menu,duden_check,duden_lang"
    });
    ```


CONFIGURATION
-------------

The following TinyMCE init parameters are supported:
##### duden_proposal_dictionary
* The name of the dictionary where proposals should be written to.
* Default: "Proposals"

##### duden_dictionaries
* The names of the dictionaries used for correction. If set to null, a default dictionary is selected by the Duden Correction Server. 
* Default: null

##### duden_text_languages
* The supported languages.
* Default: ["de-DE", "de-AT", "de-CH"]

##### duden_default_text_language
* The default language which is assumed if no language has been selected.
* Default: "de-DE"

##### duden_markup_element
* Which HTML element should be used for hightlighting errors
* Default: "span"

##### duden_proxy_script_url 
* The URL to the proxy script used for communication with the Duden Correction Server.

##### duden_allow_nested_errors
* Allow error highlighting to be nested. If disabled, outer errors are not shown until the inner error is corrected.
* Default: true

##### duden_correction_profile
* The name of the correction profile(s) to use.
* Default:  ["base"]

##### duden_proxy_without_parameter
* Switch calling conventions for proxy script from URI-encoded, parameter based settings to pass-through calling of API functions.
* Default: false

If not set or set to 'false', the proxy script is invoked by passing the desired API function as a parameter in the form "${PROXYSCRIPTURL}?function=${FUNCTION}". If set to true, the proxy script is invoked by concatenating the URL of the proy script with the desired API function in the general form "${PROXYSCRIPTURL}/${FUNCTION}". 
The first form expects a JSON response containing a "contents" field holding the result, the second form expects the result to be contained directly in the response text.

##### duden_enable_markup_removal
* Allow removal of error markup for a single error location
* Default: false

If set to 'true', the context menu for an error location is extended by the (localized) option "Remove markup for this error".
Selecting this option will remove the error markup for the corresponding spelling error to avoid interference with other 
editing options. This is a restricted version of the "Remove error markup" command that affects the *complete* text and is
normally available in the "Duden" section of the "Tools" menu. If set to false, no option will be added to the context menu. 

##### duden_enable_spell_check_on_init
* Check content immediately after initialization of tinyMCE
* Default: false
