<?PHP

/*
    Proxy script for communication with the Duden Correction Server (DCS).
*/

// CONFIGURATION ===================================================
$DCS_URL = "http://dks/api/";
// $DCS_USERNAME = "user";
// $DCS_PASSWORD = "pass";
// $DCS_PROXY = 'host:port';
// END OF CONFIGURATION ============================================


// NO CUSTOMIZATIONS REQUIRED BELOW!

$valid_function_regex = '/\w+/';
$function = $_GET['function'];
$url = $DCS_URL . $function;
if ( !$function ) {
  // Passed url not specified.
  $contents = 'ERROR: function not specified';
  $status = array( 'http_code' => 'ERROR' );

} else if ( !preg_match( $valid_function_regex, $function ) ) {
  
  // Passed url doesn't match $valid_url_regex.
  $contents = 'ERROR: invalid function name';
  $status = array( 'http_code' => 'ERROR' );
  
} else {
  $ch = curl_init( $url );
  if ( strtolower($_SERVER['REQUEST_METHOD']) == 'post' ) {
    curl_setopt( $ch, CURLOPT_POST, true );
    curl_setopt( $ch, CURLOPT_POSTFIELDS, file_get_contents("php://input"));
  }
  
  curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
  curl_setopt( $ch, CURLOPT_HEADER, true );
  curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
  
  curl_setopt( $ch, CURLOPT_USERAGENT, isset($_GET['user_agent']) ? $_GET['user_agent'] : $_SERVER['HTTP_USER_AGENT'] );
  if(isset($DCS_USERNAME) && isset($DCS_PASSWORD)) {
    curl_setopt( $ch, CURLOPT_USERPWD, $DCS_USERNAME . ":" . $DCS_PASSWORD);
  }
  if (!empty($DCS_PROXY)) {
    curl_setopt( $ch, CURLOPT_PROXY, $DCS_PROXY );
  }
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
  curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
  curl_setopt($ch, CURLOPT_HTTPHEADER, array( 'Expect:' ) );

  $response = curl_exec( $ch );
  list( $header, $contents ) = preg_split( '/([\r\n][\r\n])\\1/', $response, 2 );
  
  $status = curl_getinfo( $ch );

  curl_close( $ch );
}

// Split header text into an array.
$header_text = preg_split( '/[\r\n]+/', $header );


  // $data will be serialized into JSON data.
  $data = array();
  
  // Propagate all HTTP headers into the JSON data object.
if ( isset($_GET['full_headers']) ) {
    $data['headers'] = array();
    
    foreach ( $header_text as $header ) {
      preg_match( '/^(.+?):\s+(.*)$/', $header, $matches );
      if ( $matches ) {
        $data['headers'][ $matches[1] ] = $matches[2];
      }
    }
  }
  
  // Propagate all cURL request / response info to the JSON data object.
if ( isset($_GET['full_status']) ) {
    $data['status'] = $status;
  } else {
    $data['status'] = array();
    $data['status']['http_code'] = $status['http_code'];
  }
  
  // Set the JSON data object contents, decoding it from JSON if possible.
  $decoded_json = json_decode( $contents );
  $data['contents'] = $decoded_json ? $decoded_json : $contents;
  
  // Generate appropriate content-type header.
  $is_xhr = (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && 
           (strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest'));
  header( 'Content-type: application/' . ( $is_xhr ? 'json' : 'x-javascript' ) );
  
  // Generate JSON string
  $json = json_encode( $data );
  
  print $json;
?>
